BS-6. Minimum in Rotated Sorted Array

  Рет қаралды 183,083

take U forward

take U forward

Күн бұрын

Пікірлер: 395
@takeUforward
@takeUforward Жыл бұрын
Please comment understood and give us a like if you got everything :)
@vishnusiddarth7953
@vishnusiddarth7953 Жыл бұрын
mass
@sudhanshushekhar4222
@sudhanshushekhar4222 Жыл бұрын
Understood
@ersoumyajitpan7205
@ersoumyajitpan7205 Жыл бұрын
************ more optimized ************ int findMin(vector& nums){ int left = 0, right = nums.size() - 1; while (left < right) { int mid = left + (right - left) / 2; if (nums[mid] > nums[right]) { left = mid + 1; } else { right = mid; } } return nums[left]; }
@adil_k
@adil_k Жыл бұрын
East or west. Striver is the best
@aladdinstudios2735
@aladdinstudios2735 9 ай бұрын
I came only for Minimum in Rotated Sorted Array so why I would seen previews video #striver ?
@shivajirao999
@shivajirao999 4 ай бұрын
the feeling of writing the exact same code by your own without even looking at the lecture is insane, ALL thanks to your level of explanation
@ravikr3463
@ravikr3463 4 ай бұрын
Abe easy hai ye upper ke 3 phele se kiye hue the esiliyee btw good
@Rahul_Mongia
@Rahul_Mongia 4 ай бұрын
@@ravikr3463
@akshatgupta8787
@akshatgupta8787 4 сағат бұрын
@@ravikr3463 bhai merse wo karne ke baad bhi nahi hua yrr
@abhishekverma7604
@abhishekverma7604 Жыл бұрын
guys, this is one of the most important question if u r preparing for amazon and adobe.. hell they asked it a lot in previous 6 months according to Leetcode stats..
@animeshshaw388
@animeshshaw388 Жыл бұрын
Thanks brother 🙏🏾
@akshitbhasin7322
@akshitbhasin7322 11 ай бұрын
The fact that you acknowledged the problem of having different formats in binary search deserve a like. keep up the good work!
@HananTariq-ws9wd
@HananTariq-ws9wd Жыл бұрын
Understood!! Hi I'm a Pakistani and I study at US. I really like your DSA playlist and recommend it to everyone. Thank you so much for your effort.
@AmanSingh-wr6mj
@AmanSingh-wr6mj 7 ай бұрын
Pucha kisine?
@travelbest5623
@travelbest5623 2 ай бұрын
Ab ji*@d recruitment mai bhi dsa poochne lage kya? 😂😂
@vishious14
@vishious14 9 ай бұрын
6 minutes into the video, I was able to deduce the whole logic as soon as I understood the approach !!!!!! Amazing content !!!!!!
@ayushpatidar5778
@ayushpatidar5778 Жыл бұрын
The way you cover each and every edge case is amazing. Understood everything 👍
@surendhar.v4952
@surendhar.v4952 Жыл бұрын
If hurts the most , when you realize this easy question took you more than 2 hour and failed several time while in the test cases below 5 when you submit in leetcode. I did a course on java in youtube from a famous youtuber an year ago. I took a short break of two months for my semster exam and other activities. I can remind that I solved a similar type of question in an year ago. But now , I am struggling to do a easy problem like this.... Taking a break, even it is small gets your mind out of the programming mode.
@vaibhavvm4147
@vaibhavvm4147 10 ай бұрын
bro where did u do dsa in java from?
@harshitgarg2820
@harshitgarg2820 Жыл бұрын
Striver sir plz start a series for strings to simplify strings for us just like you did with the other topics🙏
@mehulthuletiya497
@mehulthuletiya497 Жыл бұрын
00:38 Problem statement 01:21 Brute-force approach 01:38 Optimal approach 06:30 Dry-run 10:35 Pseudocode 12:57 Code 13:20 Optimised version : If you want try to do then 15:04 Code 15:27 Complexity
@shrirambalaji2915
@shrirambalaji2915 Жыл бұрын
just watched like 7 min and understood the solution and what i am missing out thanks man you are awesome
@iWontFakeIt
@iWontFakeIt Жыл бұрын
man what an explanation ! I saw several solutions on leetcode discuss but couldn't understand all of it, some if else conditions were going above my head, but you made it so clear I did code it myself both leetcode 153 and 154 with AC solutions
@abhaymaurya9
@abhaymaurya9 3 ай бұрын
the same exact code i was able to write down without even watching your lecture first , kudos to u🙌❣
@bhushanambhore8378
@bhushanambhore8378 12 күн бұрын
I felt proud of myself of solving this question in o(logn) time without even looking this video cz obviously I've seen your previous 2 videos and of course able to solve this one 😎.. Thank you Striver.
@snigdhadatta4702
@snigdhadatta4702 3 ай бұрын
I was solving this for the first time , was struggling because everytime was giving me runtime error and guess what i lerally watched the first 10 mins only infinite times , because my dumb brain was just not convincing myself that how is this done, at 3pm night i passed this that too in 0ms time without seeing your written code 😭😭😭😭😭. It was giving me stress because i haven't been able to pass a single solution that day so i really needed anything to get accepted just to boost my morale . Thanks striver.
@RagaviSathiyamoorthy
@RagaviSathiyamoorthy 11 ай бұрын
I'm really blessed to watch and learn the concept form you striver and i'm solving the problems now without referring the solutions. Thanks a lot.
@namangarg8976
@namangarg8976 Жыл бұрын
Another approach I thought of - -> If left array is sorted, right is unsorted. Then go to right as pivot point can be current element or in right array -> If right is sorted, left is unsorted. Then go to left as pivot point can be current element or in left array -> If both are sorted then break and just compare the ans with arr[low] as complete search space is sorted. int findMin(vector& arr) { int low = 0; int high = arr.size() - 1; int ans = INT_MAX; while(low
@ompandey2911
@ompandey2911 9 ай бұрын
Was wondering, What if I search for target = INT_MIN and keep the code same as the previous video wont the arr[low] be my answer?
@SahitiDantuluri
@SahitiDantuluri 4 ай бұрын
I have gone through some solutions to this problem and able to understand but if I try to recollect and code it later I would be a little confused. But your explanation and approach is so detailed and very easy to understand that I am able to solve it on my own without any confusion (even after many days). Thanks a lot!!
@deepakff7498
@deepakff7498 3 күн бұрын
you are binary search playlist is goated bro
@parth2439
@parth2439 8 ай бұрын
Understood, the last optimisation was great !!
@visase2036
@visase2036 Жыл бұрын
Thanks Striver. Adding my thoughts for (duplicates) . If we apply the previous logic of high-- or low++ as the mid and low/high values are equal , we will end up getting the minimum element but that does not gaurentee the no of times array has been rotated . Examples: array=[1,1,2,1,1] , orignal array = [1,1,1,1,2]. The correct answer is 3 (as the element at 0th index has been moved to 3rd index [1,1,2,1,1]). But if we apply the previous logic, the answer would come as 0 as 0th index is the minimum element. To upsolve this, we can do the following : Keep reducing high, untill [high-1] > [high] (2>1). Once you attain this point, high(3rd index) will be the answer.
@floatingpoint7629
@floatingpoint7629 Жыл бұрын
this does not cover all the cases
@ayushmittal9666
@ayushmittal9666 11 ай бұрын
I think if we remove the condition of checking if(a[low]
@Cubeone11
@Cubeone11 2 ай бұрын
I used to think that neetcode gives the best explanation, but after watching this playlist i changed my thoughts.
@AyushEditz-hs6pf
@AyushEditz-hs6pf Ай бұрын
This works as well: first check if the right side of mid is sorted then check of left side. int findMin(vector& nums) { int ans=INT_MAX; int low=0; int high=nums.size()-1; while(low
@kiranmoura2974
@kiranmoura2974 Жыл бұрын
For duplicates I think the whole code will remain same only the optimized part will be changed as if (a[low]==a[mid] and a[low]==a[high]) {ans=min(ans,arr[low]); Low++; High--; Continue; Please check whether it is correct or not .
@anshuman-sl9du
@anshuman-sl9du Жыл бұрын
yeah its correct dude !! thanx i was stuck there 🤖
@omkarshendge5438
@omkarshendge5438 3 ай бұрын
yea you are right so basically the duplicates case arises when there is like mid low high all three are same so basically this case is same as search in a rotated sorted array 2 right? there also this case has rose.
@luvdhamija5157
@luvdhamija5157 9 ай бұрын
We know that if it is sorted in nature then arr[low] would always be the minimum number of all. by considering this we can simplify this as following. low=0 high=len(nums)-1 while lownums[high]: low=mid+1 elif nums[low]>nums[mid]: high=mid else: break return nums[low]
@Aks-47
@Aks-47 9 ай бұрын
slightly lengthier, but core logic is , we need to handle 2 cases where we are uncertain where to move, that was the crux for me, a) mid is less than lo and hi, b) mid greater than lo and hi, if we exclude that , then searching is regular BS, attaching java code for the same int ans = Integer.MAX_VALUE; while(lo
@Rohitkumar-bx8ne
@Rohitkumar-bx8ne 5 ай бұрын
solved without any help with BS, but before solving i have watched the previous two videos of the playlist which helped in developing the thinking skill for solving this problem
@sukhjattana5887
@sukhjattana5887 Жыл бұрын
u unfolded the mysterious binary search....thank you!!!
@samlinus836
@samlinus836 Жыл бұрын
I guess this algorithm fails for the below input: arr = [3,1,2] Your explanation is so clear bro❤ This condition should be added: min = Math.min(min,nums[mid]);
@theanimerecaphub
@theanimerecaphub Жыл бұрын
ya you have to save mid as a probable answer and compare it while moving on left
@NitinKumar-wm2dg
@NitinKumar-wm2dg Жыл бұрын
change it to nums[low] , you might get your answer, striver's code passes all the testcases
@himanshusingh1899
@himanshusingh1899 2 ай бұрын
Best DSA course on you tube.
@RAJSINGH-mr7hq
@RAJSINGH-mr7hq Жыл бұрын
Understood! Awesome explanation as always, thank you soooo much for your effort!!
@Manishgupta200
@Manishgupta200 Жыл бұрын
Other way to solve this problem is by pivot search.. Here is the approach, if(nums[nums.size()-1] > nums[0]) return nums[0]; // find pivot int s = 0, e = nums.size()-1, mid = s + (e - s) / 2; while(s < e){ if(nums[mid] >= nums[0]){ s = mid + 1; } else{ e = mid; } mid = s + (e - s) / 2; } return nums[mid];
@keerthireddy8074
@keerthireddy8074 Жыл бұрын
I think this below code is simpler and easier to understand: int findPivot(vector &nums){ int low = 0; int high = nums.size()-1; int pivot =0; // if not rotated, it should return 0 while (low
@atharva_g_vlogs
@atharva_g_vlogs Ай бұрын
UNDERSTOOD
@anuragparasharsarmah1045
@anuragparasharsarmah1045 6 ай бұрын
How I thought about this solution is, the minimum is always in the left part of the array in a normal sorted array. However in a rotated sorted array the minimum is always in the unsorted half. So we move to the unsorted right half if it exists. Otherwise we always move to the left. while(low
@motivationalcomred
@motivationalcomred Жыл бұрын
@striver take case a = [5[L] 1 2[M] 3 4[H]] mid is lesser in both arrays 2
@tanishkthakur9965
@tanishkthakur9965 5 ай бұрын
got it , understood everything
@aishezsingh7004
@aishezsingh7004 2 ай бұрын
I think This is more intutive moving towards unsorted and if sorted move left while(low arr[mid] ) high = mid - 1; else if( arr[mid] > arr[high] ) low = mid + 1; else { ans = min(ans , arr[low] ); break; } } return ans;
@MansiBansalc
@MansiBansalc 7 ай бұрын
YOU ARE AN AMAZING TEACHER! THANKYOU FOR EXISTING!
@andycharlie3255
@andycharlie3255 Жыл бұрын
woow bro, this is crazy, legendary explanation, hats off man
@nirajaya5
@nirajaya5 3 ай бұрын
Great explanation! Thank you so much.
@Manasidas99
@Manasidas99 Жыл бұрын
Understood sir thank you very much, sir. Your teaching style is really amazing. I hope I will crack my interview.
@RishabhKumar0094
@RishabhKumar0094 3 ай бұрын
understood, for duplicate elements worst case time complexity will be O(n/2).
@harishms5330
@harishms5330 2 ай бұрын
how
@RishabhKumar0094
@RishabhKumar0094 2 ай бұрын
@@harishms5330 So consider an example arr=11111111111111 size=14 it will take about O(7), if arr[low]==arr[mid]==arr[high] low++; high--; till low crosses high, it will follow the condition , at one time, low increases to 1 and high decreases to 1, so arr size reduced by 2 similarly it will go till O(n/2).
@harishms5330
@harishms5330 2 ай бұрын
@@RishabhKumar0094 thank u🫡
@jagdishkhetre4515
@jagdishkhetre4515 Жыл бұрын
Understood...Awesome Binary search Playlist.. 👏
@shreyanshdasgupta5807
@shreyanshdasgupta5807 21 күн бұрын
00:04 Find the minimum in a rotated sorted array using binary search. 02:08 Identify the sorted half in a rotated sorted array 04:19 The left portion of the rotated sorted array contains the minimum. 06:37 Identifying and eliminating the minimum element in a rotated sorted array. 08:40 Finding the smallest element in rotated sorted arrays using binary search. 11:06 Binary search on a rotated sorted array 13:13 Optimization in identifying sorted search space 15:16 Binary search stops in a sorted search space, improving time complexity
@UserUser-tn8tv
@UserUser-tn8tv 9 ай бұрын
Understood. Very Good Explanation
@dayashankarlakhotia4943
@dayashankarlakhotia4943 Жыл бұрын
Good explanation. Explanation in depth
@yossihadad8558
@yossihadad8558 10 ай бұрын
amazing!
@make4u982
@make4u982 17 күн бұрын
understood good job bro
@sunnykumarpal5087
@sunnykumarpal5087 Жыл бұрын
Bhaiya your explanation is relay fabulous. It makes hard concepts easily understandable to us. Thank you bhaiya for helping us in dsa.
@akkipinky9194
@akkipinky9194 7 ай бұрын
Thanks for the incredible knowledge u give us...understood!!
@hariomtiwari9283
@hariomtiwari9283 11 ай бұрын
Super Explanation 🎉🎉
@kingbadshah452
@kingbadshah452 8 ай бұрын
thanks striver understood everything
@aps2129
@aps2129 3 ай бұрын
Amazing explanation!!!!!
@neerajkumar-ts6om
@neerajkumar-ts6om 15 күн бұрын
You don't know how relived I am to know that you won't change format, I was afraid that it is some advance technique. I always hated binary search, hope I wouldn't after this your Binary Search Playlist
@SitaRam-m1i
@SitaRam-m1i 12 күн бұрын
Understood
@RolexGTA
@RolexGTA 10 ай бұрын
i am learn from you , one day i will cross you 🙇
@rahulsidhu5945
@rahulsidhu5945 Жыл бұрын
Understood.. Awesome Binary search Playlist..😍
@paradise836
@paradise836 6 ай бұрын
understood
@aliakbaransaria3-925
@aliakbaransaria3-925 Жыл бұрын
Very good explanation Thank you
@Anshydv3
@Anshydv3 Жыл бұрын
understood ! the best explanation bhaiya , you are hero and a real gem❤
@dipingrover1970
@dipingrover1970 5 ай бұрын
amazing explanation . thanks a lot
@adarshkumarrao3478
@adarshkumarrao3478 Жыл бұрын
UNDERSTOOD
@tanmai5414
@tanmai5414 10 күн бұрын
hey striver! will the optimized solution work for the test case [3,1,2]??
@saurabhnishad9631
@saurabhnishad9631 Күн бұрын
understood!
@rushidesai2836
@rushidesai2836 5 ай бұрын
Great question!
@baibhavghimire3827
@baibhavghimire3827 8 ай бұрын
You beat neetcode on this🎉. Superb dude.
@debapriyachandra1767
@debapriyachandra1767 Жыл бұрын
Can also be done by finding pivot. class Solution { public: int findMin(vector& nums) { int n=nums.size(); int left=0,right=n-1; while(right >= left){ int mid=(left+right)>>1; int val=nums[mid]; int prev=1e9; int next=1e9; if(mid-1>=0)prev=nums[mid-1]; if(mid+1 val && next > val)return val; if(val >= nums[left] && val >= nums[right]){ left=mid+1; } else right=mid-1; } return -1; } };
@paragroy5359
@paragroy5359 10 ай бұрын
Thanks a lot for making such videos. Your content is amazing. Keep on doing the great work
@TrinmoyDutta
@TrinmoyDutta 7 ай бұрын
while(low
@per.seus._
@per.seus._ Жыл бұрын
UNDERSTOOD❤
@ddevarapaga5134
@ddevarapaga5134 3 ай бұрын
Understood perfect bro
@myproject6768
@myproject6768 Жыл бұрын
Absolutely understand ❤
@Aryan-j7i2b
@Aryan-j7i2b 2 күн бұрын
understood!!!
@md_seraj786_
@md_seraj786_ 7 ай бұрын
understood all clear ❤
@JothiprakashThangaraj
@JothiprakashThangaraj 3 ай бұрын
understood, thanks a lot!
@AnmolGupta-oj4lm
@AnmolGupta-oj4lm Жыл бұрын
Understood Very Well!
@anshulrai6058
@anshulrai6058 Күн бұрын
understood👍
@NazeerBashaShaik
@NazeerBashaShaik 6 ай бұрын
Understood, thank you.
@abhaythakur2597
@abhaythakur2597 Жыл бұрын
very well explained
@rajatshukla2605
@rajatshukla2605 29 күн бұрын
Understood!
@heyOrca2711
@heyOrca2711 3 ай бұрын
Understood! Sir
@venkynani9892
@venkynani9892 11 ай бұрын
My thought process: int low=0; int high=arr.length-1; int min=arr[high]; while(lowmin) { low=mid+1; } else{ min=arr[mid]; high=mid-1; } } return min;
@UtsavRaj-wn5bz
@UtsavRaj-wn5bz 2 ай бұрын
Understood.
@kritikamanglam
@kritikamanglam Жыл бұрын
Understood :)
@kiranmoura2974
@kiranmoura2974 Жыл бұрын
Bahut ache se smgh aaya sir ❤
@samuelfrank1369
@samuelfrank1369 Жыл бұрын
Understood, Thanks a lot
@hengulrajsaikia9227
@hengulrajsaikia9227 Ай бұрын
The mid will point to the minimum element at least once
@RagaviSathiyamoorthy
@RagaviSathiyamoorthy 11 ай бұрын
Sir completed the problem which you gave as homework 😇😇
@NitinKumar-wm2dg
@NitinKumar-wm2dg Жыл бұрын
understood, thank you bhaiya
@thefourhourtalk
@thefourhourtalk 3 ай бұрын
a random tip : if you dont understand this (because at first I didn't get it ) take your pen and paper and dry run the example of 45123
@lakshgangwani3014
@lakshgangwani3014 Жыл бұрын
if my array is [2, 4, 1, 2], In this case wouldn't the optimised code would give the answer 2 (because of the if condition (ar[low]
@kc9049
@kc9049 Жыл бұрын
your array has a duplicate element, and the code is for the unique element.
@sayak4636
@sayak4636 Жыл бұрын
Hometask(LC-154):- class Solution { public: int findMin(vector& nums) { int s=0; int e=nums.size()-1;int ans=INT_MAX; while(s
@floatingpoint7629
@floatingpoint7629 Жыл бұрын
if interviewers ask you to modify it so it returns the index, this won't work
@6mahine_mein_google
@6mahine_mein_google Жыл бұрын
@@floatingpoint7629 In duplicates we cant return index because it would have no meaning consider [3,3,3,3,3] this as example, minimum here is 3 but index is not defined because index can be anything here. Please correct me if i am wrong
@floatingpoint7629
@floatingpoint7629 Жыл бұрын
@@6mahine_mein_google if all are duplicates then array is not a rotated one. it is guaranteed that array is at least rotated once
@piyushroy3278
@piyushroy3278 3 ай бұрын
understood sir. Huge kudos to you :)
@hakunamatata-nl4js
@hakunamatata-nl4js 4 ай бұрын
Thank you
@Shunya_Advait
@Shunya_Advait Жыл бұрын
Understood Sir. Thank You Sir 👌👌
@secondarypemail7181
@secondarypemail7181 Жыл бұрын
To find minimum element in rotated sorted aray with duplicates,just add the condition used before while finding an element in rotated sorted array with duplicates and the solution works fine.
@aniketbhura6131
@aniketbhura6131 Жыл бұрын
can you share the code
@TusharSonwane-c3d
@TusharSonwane-c3d Жыл бұрын
Understood everything
@presidenttalks8
@presidenttalks8 8 ай бұрын
Understood👍 thank you sir
@HappyHumbleHopefulHelpKey
@HappyHumbleHopefulHelpKey 2 ай бұрын
Understood ❤
BS-7. Find out how many times array has been rotated
5:01
take U forward
Рет қаралды 116 М.
BS-4. Search Element in Rotated Sorted Array - I
16:38
take U forward
Рет қаралды 277 М.
Когда отец одевает ребёнка @JaySharon
00:16
История одного вокалиста
Рет қаралды 15 МЛН
Это было очень близко...
00:10
Аришнев
Рет қаралды 6 МЛН
Human vs Jet Engine
00:19
MrBeast
Рет қаралды 131 МЛН
BS-5. Search Element in Rotated Sorted Array II
12:44
take U forward
Рет қаралды 181 М.
BS-8. Single Element in Sorted Array
22:16
take U forward
Рет қаралды 164 М.
How I would learn Leetcode if I could start over
18:03
NeetCodeIO
Рет қаралды 624 М.
I Solved 100 LeetCode Problems
13:11
Green Code
Рет қаралды 152 М.
LeetCode was HARD until I Learned these 15 Patterns
13:00
Ashish Pratap Singh
Рет қаралды 486 М.
BS-3. First and Last Occurrences in Array | Count occurrences in Array
25:28
BS-25. Search in a 2D Matrix - II  |  Binary Search on 2D
15:29
take U forward
Рет қаралды 77 М.
Когда отец одевает ребёнка @JaySharon
00:16
История одного вокалиста
Рет қаралды 15 МЛН